<template>
   <div class="layer-list-panel">
        <h3 class="text-center div_title">Couches de données</h3>
        <div class="container-infos-layers">
            <div class="mb-2 mt-2 text-center" v-if="contextService.isEditionActive">
                <b-button class="w-75 " variant="outline-secondary" @click="addGroupLayerElement()">
                    <b-icon icon="folder2-open"></b-icon> Ajouter un groupe de données
                </b-button>
            </div>

            <div class="list-group">
              <transition-group name="flip-list" tag="p">
                <div v-for="layer in getLayersAndGroups()" :key="layer.id" class="layer_strip">
                    <div class="layer-item">
                        <GroupLayerElement v-if="layer.isGroup()" v-bind:layer="layer">
                        </GroupLayerElement>
                        <SingleLayerElement v-if="!layer.isGroup()" v-bind:layer="layer">
                        </SingleLayerElement>
                    </div>
                </div>
              </transition-group>
            </div>
        </div>

        <b-row class="mb-2 mt-2 button-bottom">
            <b-col class="text-center" >
                <b-button v-if="showAddLayerBtn"
                  style="width:95%" class="bg_color-first-outlined" @click="addLayer()">
                  <b-icon icon="plus"/>&nbsp;Ajouter des données
                </b-button>
            </b-col>
            <b-col class="text-center" cols="6" v-if="contextService.isEditionActive">
                <b-button style="width:95%" class="bg_color-first-outlined" @click="addVectorLayer()"
                  v-b-tooltip.top.hover title="Ajouter une nouvelle couche de dessins ou annotations. Attention cette couche est limitée en nombre d'objets et ne peut stocker des géometries trop complexes">
                    Nouveau dessin
                </b-button>
            </b-col>
        </b-row>
    </div>
</template>

<script lang="ts">
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
import Component from 'vue-class-component';
import GroupLayerElement from '@/components/layers/GroupLayerElement.vue';
import SingleLayerElement from '@/components/layers/SingleLayerElement.vue';
import BaseComponent from '@/components/BaseComponent';
import LayerGroupConfig from '@/models/map-context/LayerGroupConfig';
import AbstractLayerTreeElement from '@/models/map-context/AbstractLayerTreeElement';
import LayerConfig from '@/models/map-context/LayerConfig';

@Component({
  props: {
  },
  components: {
    GroupLayerElement,
    SingleLayerElement,
  },
})
export default class LayerListPanel extends BaseComponent {
  static ID='LayerListPanel';

  layerGroups!:AbstractLayerTreeElement[];

  showAddLayerBtn = true;

  created() {
    console.log(this.contextService.currentContext);
    this.layerGroups = this.contextService.getCurrentContext().layers;
    console.log(this.layerGroups);
  }

  mounted() {
    this.showAddLayerBtn = this.contextService.configuration.addLayers !== undefined;
  }

  getLayersAndGroups():AbstractLayerTreeElement[] {
    return this.contextService.getCurrentContext().layers;
  }

  addLayer() {
    this.contextService.setCurrentAction('addLayer', {});
  }

  addGroupLayerElement() {
    this.contextService.getCurrentContext().getLayers().unshift(new LayerGroupConfig({
      title: 'Nouveau Groupe',
      childs: [],
    }));
    this.layerGroups = this.getLayersAndGroups();
  }

  addVectorLayer() {
    const newLayer:LayerConfig = new LayerConfig({
      title: 'Nouveau Dessin',
      type: 'Vector',
      visible: true,
      editable: true,
      layerProperties: [],
      boundingBoxEPSG4326: [-180, -90, 180, 90],
    });

    console.log(newLayer);

    try {
      this.contextService.getCurrentContext().getLayers().unshift(newLayer);
      this.getMapService().addLayer(newLayer);
    } catch (error:any) {
      newLayer.error = error;
      console.log(error);
    }
  }
}
</script>

<style scoped lang="less">
@import "../../styles/variables.less";
.layer-list-panel{
    height: 100%;
}
.container-infos-layers{
    height: calc(100% - 91px);
    border-bottom: 1px solid @grey;
    border-radius: 0px;
    overflow-y: auto;
}

.layer_strip:nth-child(even){
    background-color: fade(@first,10%);
}

.flip-list-move {
  transition: transform 0.6s;
}
</style>
